package com.mortals.xhx.module.care.web;
import com.mortals.framework.common.Rest;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.OrderCol;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.code.YesNoEnum;
import com.mortals.xhx.module.appointment.model.AppointmentRecordsEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.care.model.CareRecordsEntity;
import com.mortals.xhx.module.care.service.CareRecordsService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 预约关怀记录
*
* @author zxfei
* @date 2023-04-09
*/
@RestController
@RequestMapping("care/records")
public class CareRecordsController extends BaseCRUDJsonBodyMappingController<CareRecordsService,CareRecordsEntity,Long> {

    @Autowired
    private ParamService paramService;

    public CareRecordsController(){
        super.setModuleDesc( "预约关怀记录");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "processStatus", paramService.getParamBySecondOrganize("CareRecords","processStatus"));
        super.init(model, context);
    }


    @Override
    protected void doListBefore(CareRecordsEntity query, Map<String, Object> model, Context context) throws AppException {
        super.doListBefore(query, model, context);
        query.setOrderColList(Arrays.asList(new OrderCol("createTime",OrderCol.DESCENDING)));

    }

    /**
     * 通知负责人
     */
    @PostMapping(value = "notice")
    public String notice(@RequestBody CareRecordsEntity careRecordsEntity) {
        JSONObject jsonObject = new JSONObject();
        Map<String, Object> model = new HashMap<>();
        String busiDesc = this.getModuleDesc() + "通知负责人";
        try {
           /* Rest<String> rest = this.service.notice(careRecordsEntity, getContext());
            if(YesNoEnum.YES.getValue()==rest.getCode()){
                recordSysLog(request, busiDesc  + " 【成功】");
                jsonObject.put(KEY_RESULT_DATA, model);
                jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_SUCCESS);
                jsonObject.put(KEY_RESULT_MSG, rest.getMsg());
            }else {
                throw new AppException(rest.getMsg());
            }*/
        } catch (Exception e) {
            log.error(busiDesc, e);
            jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            jsonObject.put(KEY_RESULT_MSG, super.convertException(e));
        }
        return jsonObject.toJSONString();
    }


    /**
     * 手动关怀
     */
    @PostMapping(value = "toCare")
    public String toCare(@RequestBody CareRecordsEntity careRecordsEntity) {
        JSONObject jsonObject = new JSONObject();
        Map<String, Object> model = new HashMap<>();
        String busiDesc = this.getModuleDesc() + "toCare";
        try {
           /* Rest<String> rest = this.service.notice(careRecordsEntity, getContext());
            if(YesNoEnum.YES.getValue()==rest.getCode()){
                recordSysLog(request, busiDesc  + " 【成功】");
                jsonObject.put(KEY_RESULT_DATA, model);
                jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_SUCCESS);
                jsonObject.put(KEY_RESULT_MSG, rest.getMsg());
            }else {
                throw new AppException(rest.getMsg());
            }*/
        } catch (Exception e) {
            log.error(busiDesc, e);
            jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            jsonObject.put(KEY_RESULT_MSG, super.convertException(e));
        }
        return jsonObject.toJSONString();
    }



}